
Core - Bug # 63519

Status: Resolved Priority: Must have
Author: Ralf Zimmermann Category: File Abstraction Layer (FAL)
Created: 2014-12-02 Assigned To:
Updated: 2015-05-15 Due date:
TYPO3 Version: 6.2
PHP Version: 5.3
Complexity: medium
Is Regression: No
Sprint Focus: On Location Sprint
Subject: sys_file_processedfile rows contain zero dimensions
Description

There is an error with the scaling process if the same picture is placed multiple times on the same page.
Some rows from table sys_file_processedfile contain zero values for width and height although the serialized configuration contains
settings for width and height.

The LocalDriver moves the temporary (scaled) file after scaling but the GraphicalFunctions (scaling process)
assumes (on the basis of a database query) at the next time that the temporary file exists and try to get the image dimensions on a
not existing file.
Nothing is returned and a zero value reaches the Database.

...
\TYPO3\CMS\Core\Resource\Processing\LocalImageProcessor::processTask()
60: $helper = $this->getHelperByTaskName($task->getName());
62: $result = $helper->process($task);

\TYPO3\CMS\Core\Resource\Processing\LocalCropScaleMaskHelper::process()
75: $result = $gifBuilder->imageMagickConvert(
        $originalFileName,
        $configuration['fileExtension'],
        $configuration['width'],
        $configuration['height'],
        $configuration['additionalParameters'],
        $configuration['frame'],
        $options
    );

\TYPO3\CMS\Core\Imaging\GraphicalFunctions::imageMagickConvert()
2258: $output = $this->absPrefix . $this->tempPath . 'pics/' . $this->filenamePrefix . $theOutputName . '.' . $newExt;

$output contains the temporary filename like /var/www/basisbox.local/htdocs/typo3temp/pics/5e0e4724b9.jpg

\TYPO3\CMS\Core\Imaging\GraphicalFunctions::file_exists_typo3temp_file()
This function look into the database for a entry that contain the temporary filepath ($output).
If the entry exist no scaling will be performed because there is already an temporary file.

2261: if ($this->dontCheckForExistingTempFile || !$this->file_exists_typo3temp_file($output, $imagefile)) {
2262:   $this->imageMagickExec($imagefile, $output, $command, $frame);
2263: }
2264: if (file_exists($output)) {

After the file_exists_typo3temp_file() check, we check the existence of the temporary file again and return its dimensions.
If the file does not exist, nothing will be returned.

Back to the processTask

\TYPO3\CMS\Core\Resource\Processing\LocalImageProcessor::processTask()
73: $task->getTargetFile()->updateWithLocalFile($result['filePath']);

After the scaling the scaled file will be added to the storage
$result['filePath'] contain the temporary filepath eg. /var/www/basisbox.local/htdocs/typo3temp/pics/5e0e4724b9.jpg

\TYPO3\CMS\Core\Resource\ProcessedFile::updateWithLocalFile()
181: $addedFile = $this->storage->updateProcessedFile($filePath, $this);

\TYPO3\CMS\Core\Resource\ResourceStorage::updateProcessedFile()
1118: $fileIdentifier = $this->driver->addFile($localFilePath, $this->getProcessingFolder()->getIdentifier(),
$processedFile->getName());

\TYPO3\CMS\Core\Resource\Driver\LocalDriver::addFile()
662: $result = rename($localFilePath, $targetPath);

At this point the temporary file /var/www/basisbox.local/htdocs/typo3temp/pics/5e0e4724b9.jpg will be moved to another location.
The next scaling process will fail because
\TYPO3\CMS\Core\Imaging\GraphicalFunctions::file_exists_typo3temp_file()
find a database record that contains this filename.
The process don't render the file again because
\TYPO3\CMS\Core\Imaging\GraphicalFunctions::imageMagickConvert()
2264: if (file_exists($output)) {
don't find the file and return nothing and the sys_file_processedfile row will be filled with height = 0 and width = 0

Related issues:
related to Core - Task # 64643: Remove feature enable_typo3temp_db_tracking Resolved 2015-01-30
related to Core - Bug # 62400: Lot of entries in sys_file_processed with name... Rejected 2014-10-22
related to Core - Bug # 65842: Cropping Images in GIFBUILDER is broken since ... Resolved 2015-03-19

Associated revisions
Revision c5b7a0d9 - 2015-05-15 14:28 - Morton Jonuschat

[BUGFIX] Temporary filename collision in imageMagickConvert()

Add more entropy to the temporary filename used by imageMagickConvert()
to ensure different processing configurations resulting in the same
output dimensions get different temporary names.
In combination with LocalDriver moving the temporary file to a different
location and file_exists_typo3temp_file() having a 30s window where it
doesn't detect the moved file (when the user enabled
$TYPO3_CONF_VARS['GFX']['enable_typo3temp_db_tracking']) this
leads to entries in the sys_processed_file table with a width and
height of 0, thus referencing the original file and resulting in
unscaled images showing in the frontend.

Resolves: #65842
Resolves: #63519
Resolves: #60215
Related: #65378
Releases: 6.2
Change-Id: I42748d0899bf1e24f9f92f2e55802d64309c5704
Reviewed-on: http://review.typo3.org/39373
Reviewed-by: Stephan Großberndt <stephan@grossberndt.de>
Reviewed-by: Frans Saris <franssaris@gmail.com>
Reviewed-by: Andreas Fernandez <typo3@scripting-base.de>
Tested-by: Andreas Fernandez <typo3@scripting-base.de>
Reviewed-by: Markus Klein <markus.klein@typo3.org>
Tested-by: Markus Klein <markus.klein@typo3.org>

History
#1 - 2014-12-03 12:16 - Ralf Zimmermann

I forgot to mention this happens if GFX[enable_typo3temp_db_tracking] = 1

#2 - 2015-01-18 21:32 - Ingo Schmitt
- Sprint Focus set to On Location Sprint

#3 - 2015-01-30 16:17 - Ingo Schmitt
- Complexity set to medium

#4 - 2015-01-30 17:34 - Ingo Schmitt

We should check, if this is still present after applying 64643. Because  GFX[enable_typo3temp_db_tracking] is removed.

#5 - 2015-01-30 17:36 - Bjoern Jacob

#64643 removes GFX[enable_typo3temp_db_tracking] only for 7.x. So the bug is still in 6.2 present.

#6 - 2015-05-08 22:13 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39372
#7 - 2015-05-08 22:23 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39373

#8 - 2015-05-08 22:35 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39373

#9 - 2015-05-08 23:06 - Gerrit Code Review

Patch set 3 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/39373

#10 - 2015-05-15 14:30 - Morton Jonuschat
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:c5b7a0d92d66ee670d53f976511e44540682195e.
